import os
#from time import time
#import xarray as xr
#import rioxarray
import fiona
import rasterio
import rasterio.mask as msk
import numpy as np
from datetime import date, datetime
from dateutil.rrule import rrule, MONTHLY
import pandas as pd


# Function to perform zonal mean on polygon and output data in csv file

def zonal_stats(shape_path, infile, parameter,
                dict={"Year": [], "month": [], 'id': [], 'mean': []}):
    # === Zonal Stats ===
    with fiona.open(shape_path, 'r') as shp:
        features = [feature for feature in shp]
        print(features)
        with rasterio.open(infile) as src:
            for f in features:
                src_shp = [f['geometry']]
                outimage, out_transform = msk.mask(src, src_shp, crop=True)
                #print(outimage)
                print('type: ', type(outimage))
                ws_id = f['id']
                #ws_name = f['properties']['COUNTRY']
                ws_ar = outimage
                ws_ar[ws_ar < 0] = np.nan
                ws_mean = np.nanmean(ws_ar)
                print(ws_mean)
                ws_year = infile.split('.')[0][-6:-2]
                ws_doy = infile.split('.')[0][-2:]
                #dict['name'].append(ws_name)
                dict['mean'].append(ws_mean)
                dict['Year'].append(ws_year)
                dict['month'].append(ws_doy)
                #dict['YYYYDOY'].append('{}_{}'.format(ws_year,ws_doy))
                #dict['parameter'].append(parameter)
                dict['id'].append(ws_id)
    del(shp, src)
    return dict

path_mos_dat = r'W:\Users\Stefanie\IWMI\Awash_basin\L8_9_52%_169-166_051-054\data\merge_clip'
parameter = 'eta'

#shape_path = r'W:\Users\Stefanie\IWMI\Amibara\Amibara_GCS_nozval.shp'   #_LSscene_projection.shp'
shape_path = r'W:\Users\Stefanie\IWMI\Awash_basin\awash_basin_wgs84.shp'
csv_output = r'W:\Users\Stefanie\IWMI\Awash_basin'  # output folder where csv file is saved
# keep the last x rows (x shapes in shapefile)
xx = 1

startyear = 2020
endyear = 2024
outfile_name = 'zonalmean_Awash_20202024'

a = datetime(startyear, 1, 1)
#num_of_years = 2
# count = 12 * num_of_years  or how many monthly files are there

i = 1
for dt in rrule(MONTHLY, count=57, dtstart=a):  # 252
    print(dt)
    print(i)
    # print(dt.strftime("%Y-%m")) # this returns string
    year = dt.strftime("%Y")
    month = dt.strftime("%m")
    print('averaging: {}-{}'.format(year, month))
    column_date = ('{}_{}'.format(year, month))

    #in_file = os.path.join(path_mos_dat, year, '{}_{}{}.tif'.format(parameter, year, month))
    in_file = os.path.join(path_mos_dat, '{}_{}{}.tif'.format(parameter, year, month))
    #print(in_file)

    if i == 1:
        outdict = zonal_stats(shape_path, in_file, parameter)
        #print(outdict)
        print(f'keys {i}',len(outdict.keys()))
        csvdf = pd.DataFrame(outdict, columns=['id', 'mean'])
        csvdf.set_index('id', drop=True, append=False, inplace=True, verify_integrity=False)
        csvdf.rename({'mean': column_date}, axis=1, inplace=True)  #new method
        print(csvdf)
        del (outdict)
    else:
        print('i am here now')
        outdict = zonal_stats(shape_path, in_file, parameter)
        print(f'keys {i}',len(outdict.keys()))
        #print(outdict)
        # Create dataframe for next month
        csvdf_1 = pd.DataFrame(outdict, columns=['id', 'mean'])
        # keep the last x rows (x shapes in shapefile)
        csvdf_1 = csvdf_1.tail(xx)
        print(csvdf_1)
        # make the id the index (label)
        csvdf_1.set_index('id', drop=True, append=False, inplace=True, verify_integrity=False)
        # rename the mean value with the monthly date, axis=1 -> do it for the columns
        csvdf_1.rename({'mean': column_date}, axis=1, inplace=True)
        print(csvdf_1)
        # attach the next month to the dataframe as last column
        csvdf = csvdf.join(csvdf_1[column_date])
        print(csvdf)

        # clean up
        del(outdict)
        del(csvdf_1)

    i += 1
#print(csvdf.set_option('display.max_columns', None))
csvdf.to_csv(os.path.join(csv_output, '{}_{}.csv'.format(parameter, outfile_name)))
print('done')
